## openser-svn-bfriedrich-2007-03-26.tar.gz

=== Makefile ===
# $Id: Makefile 1783 2007-03-09 14:51:26Z miconda $
#
# sip_router makefile
#
# WARNING: requires gmake (GNU Make)
#  Arch supported: Linux, FreeBSD, SunOS (tested on Solaris 8), OpenBSD (3.2),
#  NetBSD (1.6).
#
#  History:
#  --------
#              created by andrei
#  2003-02-24  make install no longer overwrites openser.cfg  - patch provided
#               by Maxim Sobolev   <sobomax@FreeBSD.org> and 
#                  Tomas Bjrklund <tomas@webservices.se>
#  2003-03-11  PREFIX & LOCALBASE must also be exported (andrei)
#  2003-04-07  hacked to work with solaris install (andrei)
#  2003-04-17  exclude modules overwritable from env. or cmd. line,
#               added include_modules and skip_modules (andrei)
#  2003-05-30  added extra_defs & EXTRA_DEFS
#               Makefile.defs force-included to allow recursive make
#               calls -- see comment (andrei)
#  2003-06-02  make tar changes -- unpacks in $NAME-$RELEASE  (andrei)
#  2003-06-03  make install-cfg will properly replace the module path
#               in the cfg (re: /usr/.*lib/openser/modules)
#              openser.cfg.default is installed only if there is a previous
#               cfg. -- fixes packages containing openser.cfg.default (andrei)
#  2003-08-29  install-modules-doc split from install-doc, added 
#               install-modules-all, removed README.cfg (andrei)
#              added skip_cfg_install (andrei)
#  2004-09-02  install-man will automatically "fix" the path of the files
#               referred in the man pages
#

#TLS=1
#FREERADIUS=1
auto_gen=lex.yy.c cfg.tab.c   #lexx, yacc etc

#include  source related defs
include Makefile.sources

# whether or not to install openser.cfg or just openser.cfg.default
# (openser.cfg will never be overwritten by make install, this is usefull
#  when creating packages)
skip_cfg_install?=

#extra modules to exclude
skip_modules?=

# if not set on the cmd. line or the env, exclude this modules:
exclude_modules?= 		jabber cpl-c mysql pa postgres osp unixodbc \
						avp_radius auth_radius group_radius uri_radius xmpp \
						presence pua pua_mi pua_usrloc \
						mi_xmlrpc perl snmpstats
ifeq ($(TLS),)
	exclude_modules+= tlsops
endif
# always exclude the SVN dir
override exclude_modules+= .svn $(skip_modules)

#always include this modules
include_modules?=

# first 2 lines are excluded because of the experimental or incomplete
# status of the modules
# the rest is excluded because it depends on external libraries
#
static_modules=
static_modules_path=$(addprefix modules/, $(static_modules))
extra_sources=$(wildcard $(addsuffix /*.c, $(static_modules_path)))
extra_objs=$(extra_sources:.c=.o)

static_defs= $(foreach  mod, $(static_modules), \
		-DSTATIC_$(shell echo $(mod) | tr [:lower:] [:upper:]) )

override extra_defs+=$(static_defs) $(EXTRA_DEFS)
export extra_defs

modules=$(filter-out $(addprefix modules/, \
			$(exclude_modules) $(static_modules)), \
			$(wildcard modules/*))
modules:=$(filter-out $(modules), $(addprefix modules/, $(include_modules) )) \
			$(modules)
modules_names=$(shell echo $(modules)| \
				sed -e 's/modules\/\([^/ ]*\)\/*/\1.so/g' )
modules_basenames=$(shell echo $(modules)| \
				sed -e 's/modules\/\([^/ ]*\)\/*/\1/g' )
#modules_names=$(patsubst modules/%, %.so, $(modules))
modules_full_path=$(join  $(modules), $(addprefix /, $(modules_names)))

MODULE_MYSQL_INCLUDED=$(shell echo $(modules)| grep mysql )
ifeq (,$(MODULE_MYSQL_INCLUDED))
	MYSQLON=no
else
	MYSQLON=yes
endif
MODULE_PGSQL_INCLUDED=$(shell echo $(modules)| grep postgres )
ifeq (,$(MODULE_PGSQL_INCLUDED))
	PGSQLON=no
else
	PGSQLON=yes
endif

ALLDEP=Makefile Makefile.sources Makefile.defs Makefile.rules

#include general defs (like CC, CFLAGS  a.s.o)
# hack to force makefile.defs re-inclusion (needed when make calls itself with
# other options -- e.g. make bin)
makefile_defs=0
DEFS:=
include Makefile.defs

NAME=$(MAIN_NAME)

#export relevant variables to the sub-makes
export DEFS PROFILE CC LD MKDEP MKTAGS CFLAGS LDFLAGS MOD_CFLAGS MOD_LDFLAGS 
export LIBS RADIUS_LIB
export LEX YACC YACC_FLAGS
export PREFIX LOCALBASE SYSBASE
# export relevant variables for recursive calls of this makefile 
# (e.g. make deb)
#export LIBS
#export TAR 
export NAME RELEASE OS ARCH 
export cfg-prefix cfg-dir bin-prefix bin-dir modules-prefix modules-dir
export doc-prefix doc-dir man-prefix man-dir ut-prefix ut-dir lib-dir
export cfg-target modules-target
export INSTALL INSTALL-CFG INSTALL-BIN INSTALL-MODULES INSTALL-DOC INSTALL-MAN 
export INSTALL-TOUCH

ifneq ($(TLS),)
	tar_extra_args+=
else
	tar_extra_args+=--exclude=$(notdir $(CURDIR))/tls* 
endif
# include the common rules
include Makefile.rules

#extra targets 

$(NAME): $(extra_objs) # static_modules

lex.yy.c: cfg.lex cfg.tab.h $(ALLDEP)
	$(LEX) $<

cfg.tab.c cfg.tab.h: cfg.y  $(ALLDEP)
	$(YACC) $(YACC_FLAGS) $<

.PHONY: all
all: $(NAME) modules utils



.PHONY: modules
modules:
	@set -e; \
	for r in $(modules) "" ; do \
		if [ -n "$$r" ]; then \
			echo  "" ; \
			echo  "" ; \
			$(MAKE) -C $$r ; \
		fi ; \
	done 

.PHONY: modules-readme
modules-readme:
	@set -e; \
	for r in  $(modules_basenames) "" ; do \
		if [ -d "modules/$$r/doc" ]; then \
			cd "modules/$$r/doc" ; \
			if [ -f "$$r".sgml ]; then \
				echo  "" ; \
				echo  "docbook2txt $$r.sgml" ; \
				docbook2txt "$$r".sgml ; \
				mv "$$r".txt ../README ; \
			fi ; \
			cd ../../.. ; \
		fi ; \
	done 

.PHONY: modules-docbook-txt
modules-docbook-txt:
	@set -e; \
	for r in  $(modules_basenames) "" ; do \
		if [ -d "modules/$$r/doc" ]; then \
			cd "modules/$$r/doc" ; \
			if [ -f "$$r".sgml ]; then \
				echo  "" ; \
				echo  "docbook2txt $$r.sgml" ; \
				docbook2txt "$$r".sgml ; \
			fi ; \
			cd ../../.. ; \
		fi ; \
	done 

.PHONY: modules-docbook-html
modules-docbook-html:
	@set -e; \
	for r in  $(modules_basenames) "" ; do \
		if [ -d "modules/$$r/doc" ]; then \
			cd "modules/$$r/doc" ; \
			if [ -f "$$r".sgml ]; then \
				echo  "" ; \
				echo  "docbook2html -u $$r.sgml" ; \
				docbook2html -u "$$r".sgml ; \
			fi ; \
			cd ../../.. ; \
		fi ; \
	done 

.PHONY: modules-docbook-pdf
modules-docbook-pdf:
	@set -e; \
	for r in  $(modules_basenames) "" ; do \
		if [ -d "modules/$$r/doc" ]; then \
			cd "modules/$$r/doc" ; \
			if [ -f "$$r".sgml ]; then \
				echo  "" ; \
				echo  "docbook2pdf $$r.sgml" ; \
				docbook2pdf "$$r".sgml ; \
			fi ; \
			cd ../../.. ; \
		fi ; \
	done 

.PHONY: modules-docbook
modules-docbook: modules-docbook-txt modules-docbook-html modules-docbook-pdf


$(extra_objs):
	-@echo "Extra objs: $(extra_objs)" 
	@set -e; \
	for r in $(static_modules_path) "" ; do \
		if [ -n "$$r" ]; then \
			echo  "" ; \
			echo  "Making static module $r" ; \
			$(MAKE) -C $$r static ; \
		fi ; \
	done 


	
dbg: $(NAME)
	gdb -command debug.gdb

.PHONY: tar
.PHONY: dist

dist: tar

tar: 
	$(TAR) -C .. \
		--exclude=$(notdir $(CURDIR))/test* \
		--exclude=$(notdir $(CURDIR))/tmp* \
		--exclude=$(notdir $(CURDIR))/debian* \
		--exclude=.svn* \
		--exclude=*.[do] \
		--exclude=*.so \
		--exclude=*.il \
		--exclude=$(notdir $(CURDIR))/$(NAME) \
		--exclude=*.gz \
		--exclude=*.bz2 \
		--exclude=*.tar \
		--exclude=*.patch \
		--exclude=.\#* \
		--exclude=*.swp \
		${tar_extra_args} \
		-cf - $(notdir $(CURDIR)) | \
			(mkdir -p tmp/_tar1; mkdir -p tmp/_tar2 ; \
			    cd tmp/_tar1; $(TAR) -xf - ) && \
			    mv tmp/_tar1/$(notdir $(CURDIR)) \
			       tmp/_tar2/"$(NAME)-$(RELEASE)" && \
			    (cd tmp/_tar2 && $(TAR) \
			                    -zcf ../../"$(NAME)-$(RELEASE)_src".tar.gz \
			                               "$(NAME)-$(RELEASE)" ) ; \
			    rm -rf tmp/_tar1; rm -rf tmp/_tar2

# binary dist. tar.gz
.PHONY: bin
bin:
	mkdir -p tmp/$(NAME)/usr/local
	$(MAKE) install basedir=tmp/$(NAME) prefix=/usr/local 
	$(TAR) -C tmp/$(NAME)/ -zcf ../$(NAME)-$(RELEASE)_$(OS)_$(ARCH).tar.gz .
	rm -rf tmp/$(NAME)

.PHONY: deb
deb:
	ln -sf packaging/debian
	dpkg-buildpackage -rfakeroot -tc $(DEBBUILD_EXTRA_OPTIONS)
	rm -f debian

.PHONY: sunpkg
sunpkg:
	mkdir -p tmp/$(NAME)
	mkdir -p tmp/$(NAME)_sun_pkg
	$(MAKE) install basedir=tmp/$(NAME) prefix=/usr/local
	(cd packaging/solaris; \
	pkgmk -r ../../tmp/$(NAME)/usr/local -o -d ../../tmp/$(NAME)_sun_pkg/ -v "$(RELEASE)" ;\
	cd ../..)
	cat /dev/null > ../$(NAME)-$(RELEASE)-$(OS)-$(ARCH)-local
	pkgtrans -s tmp/$(NAME)_sun_pkg/ ../$(NAME)-$(RELEASE)-$(OS)-$(ARCH)-local \
		OpenSER
	gzip -9 ../$(NAME)-$(RELEASE)-$(OS)-$(ARCH)-local
	rm -rf tmp/$(NAME)
	rm -rf tmp/$(NAME)_sun_pkg


.PHONY: install
install: all mk-install-dirs install-cfg install-bin install-modules \
	install-doc install-man

.PHONY: dbinstall
dbinstall:
	-@echo "Initializing $(NAME) database"
	scripts/mysqldb.sh create
	-@echo "Done"

mk-install-dirs: $(cfg-prefix)/$(cfg-dir) $(bin-prefix)/$(bin-dir) \
			$(modules-prefix)/$(modules-dir) $(doc-prefix)/$(doc-dir) \
			$(man-prefix)/$(man-dir)/man8 $(man-prefix)/$(man-dir)/man5

$(cfg-prefix)/$(cfg-dir): 
		mkdir -p $(cfg-prefix)/$(cfg-dir)

$(bin-prefix)/$(bin-dir):
		mkdir -p $(bin-prefix)/$(bin-dir)

$(modules-prefix)/$(modules-dir):
		mkdir -p $(modules-prefix)/$(modules-dir)


$(doc-prefix)/$(doc-dir):
		mkdir -p $(doc-prefix)/$(doc-dir)

$(man-prefix)/$(man-dir)/man8:
		mkdir -p $(man-prefix)/$(man-dir)/man8

$(man-prefix)/$(man-dir)/man5:
		mkdir -p $(man-prefix)/$(man-dir)/man5
		
# note: on solaris 8 sed: ? or \(...\)* (a.s.o) do not work
install-cfg: $(cfg-prefix)/$(cfg-dir)
		sed -e "s#/usr/.*lib/$(NAME)/modules/#$(modules-target)#g" \
			< etc/$(NAME).cfg > $(cfg-prefix)/$(cfg-dir)$(NAME).cfg.sample0
		sed -e "s#/usr/.*etc/$(NAME)/tls/#$(cfg-target)tls/#g" \
			< $(cfg-prefix)/$(cfg-dir)$(NAME).cfg.sample0 \
			> $(cfg-prefix)/$(cfg-dir)$(NAME).cfg.sample
		rm -fr $(cfg-prefix)/$(cfg-dir)$(NAME).cfg.sample0
		chmod 644 $(cfg-prefix)/$(cfg-dir)$(NAME).cfg.sample
		if [ -z "${skip_cfg_install}" -a \
				! -f $(cfg-prefix)/$(cfg-dir)$(NAME).cfg ]; then \
			mv -f $(cfg-prefix)/$(cfg-dir)$(NAME).cfg.sample \
				$(cfg-prefix)/$(cfg-dir)$(NAME).cfg; \
		fi
		# radius dictionary
		$(INSTALL-TOUCH) $(cfg-prefix)/$(cfg-dir)/dictionary.radius
		$(INSTALL-CFG) etc/dictionary.radius $(cfg-prefix)/$(cfg-dir)
		# openserctl config
		$(INSTALL-TOUCH)   $(cfg-prefix)/$(cfg-dir)/openserctlrc.sample
		$(INSTALL-CFG) scripts/openserctlrc \
			$(cfg-prefix)/$(cfg-dir)/openserctlrc.sample
		if [ ! -f $(cfg-prefix)/$(cfg-dir)/openserctlrc ]; then \
			mv -f $(cfg-prefix)/$(cfg-dir)/openserctlrc.sample \
				$(cfg-prefix)/$(cfg-dir)/openserctlrc; \
		fi
		#$(INSTALL-CFG) etc/$(NAME).cfg $(cfg-prefix)/$(cfg-dir)
		if [ "$(TLS)" != "" ] ; then \
			mkdir -p $(cfg-prefix)/$(cfg-dir)/tls ; \
			mkdir -p $(cfg-prefix)/$(cfg-dir)/tls/rootCA ; \
			mkdir -p $(cfg-prefix)/$(cfg-dir)/tls/rootCA/certs ; \
			mkdir -p $(cfg-prefix)/$(cfg-dir)/tls/rootCA/private ; \
			mkdir -p $(cfg-prefix)/$(cfg-dir)/tls/user ; \
			(cd etc ; \
			for FILE in tls/* tls/rootCA/* tls/rootCA/certs/* \
					tls/rootCA/private/* tls/user/* ; do \
				if [ -f $$FILE ] ; then \
					$(INSTALL-TOUCH) $$FILE \
						$(cfg-prefix)/$(cfg-dir)/$$FILE ; \
					$(INSTALL-CFG) $$FILE \
						$(cfg-prefix)/$(cfg-dir)/$$FILE ; \
				fi ;\
			done ) ; \
		fi

install-bin: $(bin-prefix)/$(bin-dir) utils
		$(INSTALL-TOUCH) $(bin-prefix)/$(bin-dir)/$(NAME) 
		$(INSTALL-BIN) $(NAME) $(bin-prefix)/$(bin-dir)
		cat scripts/openserctl | \
		sed -e "s#/usr/local/sbin#$(bin-target)#g" | \
		sed -e "s#/usr/local/lib/openser#$(lib-target)#g" | \
		sed -e "s#/usr/local/etc/openser#$(cfg-target)#g"  >/tmp/openserctl
		$(INSTALL-TOUCH) $(bin-prefix)/$(bin-dir)/openserctl
		$(INSTALL-BIN) /tmp/openserctl $(bin-prefix)/$(bin-dir)
		rm -fr /tmp/openserctl
		sed -e "s#/usr/local/sbin#$(bin-target)#g" \
			< scripts/openserctl.base > /tmp/openserctl.base
		mkdir -p $(modules-prefix)/$(lib-dir)/openserctl 
		$(INSTALL-TOUCH) \
			$(modules-prefix)/$(lib-dir)/openserctl
		$(INSTALL-CFG) /tmp/openserctl.base \
			$(modules-prefix)/$(lib-dir)/openserctl/openserctl.base

=== modules/acc/Makefile ===
# $Id: Makefile 1515 2007-01-16 21:25:55Z bogdan_iancu $
#
# acc module makefile
#
#
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=acc.so
LIBS=

# uncomment the next line if you wish to enable SQL accounting
DEFS+=-DSQL_ACC

# uncomment the next two lines if you wish to enable RADIUS accounting
#DEFS+=-DRAD_ACC -I$(LOCALBASE)/include
#LIBS=-L$(LOCALBASE)/lib $(RADIUS_LIB)

# uncomment the next two lines if you wish to enable DIAMETER accounting
#DEFS+=-DDIAM_ACC

include ../../Makefile.modules

=== modules/auth_diameter/Makefile ===
# $Id: Makefile 2 2005-06-13 16:47:24Z bogdan_iancu $
#
# Digest Authentication - Diameter support
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

auto_gen=
NAME=auth_diameter.so

include ../../Makefile.modules

=== modules/mi_xmlrpc/Makefile ===
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=mi_xmlrpc.so
LIBS=

DEFS+=-I$(LOCALBASE)/include
LIBS+=-L$(SYSBASE)/lib  -L$(LOCALBASE)/lib -lxmlrpc -lxmlrpc_xmlparse \
      -lxmlrpc_xmltok -lxmlrpc_abyss -lxmlrpc_abyss_server \
       -lxmlrpc_client -lwwwinit -lwwwstream -lwwwxml

include ../../Makefile.modules

=== modules/mysql/Makefile ===
# $Id: Makefile 1619 2007-02-12 18:17:05Z bogdan_iancu $
#
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=mysql.so

# mysql.h locations (freebsd,openbsd  solaris)
DEFS +=-I$(LOCALBASE)/include -I$(LOCALBASE)/include/mysql \
		-I$(LOCALBASE)/mysql/include/mysql -I$(LOCALBASE)/mysql/include \
		-I$(SYSBASE)/include/mysql

# libmysqlclient locations on RH/Suse, Solaris /OpenBSD, FreeBSD
# (Debian does the right thing and puts it in /usr/lib)
LIBS=-L$(SYSBASE)/lib/mysql -L$(LOCALBASE)/lib -L$(LOCALBASE)/lib/mysql \
		-L$(LOCALBASE)/mysql/lib/mysql/ \
		-L$(LOCALBASE)/mysql/lib \
		-L$(SYSBASE)/lib64/mysql \
		-lm -lmysqlclient -lz

include ../../Makefile.modules

=== modules/osp/Makefile ===

# osp module makefile

# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=osp.so
DEFS+=-D_POSIX_THREADS

LIBS=$(shell if [ -f $(SYSBASE)/local/lib/libosptk.a ]; then echo "-losptk" ; else echo "-losp" ; fi)
LIBS+=-lssl -lcrypto -lpthread -lm



include ../../Makefile.modules

=== modules/pa/Makefile ===
# $Id: Makefile 318 2005-10-25 16:23:28Z bogdan_iancu $
#
# Presence Agent
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=pa.so
LIBS=

DEFS+=-I/usr/include/libxml2 -I$(LOCALBASE)/include/libxml2 -I$(LOCALBASE)/include
LIBS+=-L/usr/include/lib  -L$(LOCALBASE)/lib -lxml2

include ../../Makefile.modules

=== modules/perl/Makefile ===
# $Id: Makefile 863 2007-03-06 19:38:40Z bastian $
#
# perl module makefile
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=perl.so

ifeq ($(PERLLDOPTS),)
	LIBS+=`perl -MExtUtils::Embed -e ldopts`
else
	LIBS+=$(PERLLDOPTS)
endif

ifeq ($(PERLCCOPTS),)
	DEFS+=`perl -MExtUtils::Embed -e ccopts`
else
	DEFS+=$(PERLCCOPTS)
endif



########
# For coverage analysis with gcov:
#LIBS+=-fprofile-arcs -ftest-coverage
#DEFS+=-O0 -fprofile-arcs -ftest-coverage

include ../../Makefile.modules

PODFILES=openserxs.xs `find lib/perl -name *.pm`

ifeq ($(TYPEMAP),)
	ifeq ($(PERLLIBPATH),)
		PERLLIBPATH=`perl -MConfig -e 'print $$Config{installprivlib}'`
	endif
	TYPEMAP=$(PERLLIBPATH)/ExtUtils/typemap
endif

perl.d: openserxs.o
perl.o: perl.c openserxs.o

openserxs.o: openserxs.c openserxs.d
	$(CC) $(MOD_CFLAGS) -Wno-unused $(DEFS) -c -o openserxs.o openserxs.c

openserxs.c: openserxs.xs typemap
	xsubpp -typemap $(TYPEMAP) -typemap typemap openserxs.xs > openserxs.c

clean:	clean-special

.PHONY: clean-special
clean-special:
	rm -f openserxs.c openserxs.o openserxs.d

.PHONY: perlpod
perlpod: doc/perl_pod.sgml

doc/perl_pod.sgml: openserxs.xs
	cat $(PODFILES) | pod2docbook --doctype=chapter --title='OpenSER Perl API' --no-header - doc/perl_pod.sgml

=== modules/postgres/Makefile ===
# $Id: Makefile 1633 2007-02-14 09:52:55Z bogdan_iancu $
#
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=postgres.so

# libpq-fe.h locations
DEFS +=-I$(LOCALBASE)/include -I$(LOCALBASE)/pgsql/include \
	 -I$(SYSBASE)/include/postgresql -I$(SYSBASE)/include/postgresql/8.0
LIBS=-L$(LOCALBASE)/lib -L$(LOCALBASE)/pgsql/lib -L$(LOCALBASE)/lib/pgsql \
	 -lpq

include ../../Makefile.modules

=== modules/snmpstats/Makefile ===
# $Id: Makefile 1770 2007-03-08 13:40:01Z bogdan_iancu $
#
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs

BUILDER = $(shell which net-snmp-config)
ifeq ($(BUILDER),)
	DEFS +=-I$(LOCALBASE)/include
	BUILDAGENTLIBS =-L$(LOCALBASE)/lib -lnetsnmpmibs -lnetsnmpagent \
		-lnetsnmphelpers -lnetsnmp
	INSTALLMIBDIR = $(cfg-prefix)/share/snmp/mibs
else
	BUILDAGENTLIBS = $(shell net-snmp-config --agent-libs)
	INSTALLMIBDIR = $(cfg-prefix)$(shell net-snmp-config --prefix)/share/snmp/mibs
endif 

CFLAGS+=
auto_gen=
NAME=snmpstats.so
LIBS=$(BUILDAGENTLIBS)


include ../../Makefile.modules

install_module_custom:
	echo "installing mibs ..."
	mkdir -p $(INSTALLMIBDIR)
	$(INSTALL-CFG) mibs/OPENSER* $(INSTALLMIBDIR)

=== packaging/freebsd/Makefile ===
# New ports collection makefile for:	openser
# Date created:				20 October 2005
# Whom:					jesusr
#
# $FreeBSD: ports/net/openser/Makefile,v 1.4 2006/06/22 14:08:48 johans Exp $
#

PORTNAME=	openser
PORTVERSION=	1.2.0
CATEGORIES=	net
MASTER_SITES=	http://openser.org/pub/openser/${PORTVERSION}/src/
DISTNAME=	${PORTNAME}-${PORTVERSION}-tls_src

MAINTAINER=	jesusr@FreeBSD.org
COMMENT=	A very fast and configurable SIP proxy with TLS support

LIB_DEPENDS=	radiusclient-ng.2:${PORTSDIR}/net/radiusclient

WRKSRC=		${WRKDIR}/${PORTNAME}-${PORTVERSION}-tls

USE_GMAKE=	yes
USE_GNOME=	libxml2
MAKE_ENV=	CC="${CC}" \
		CC_EXTRA_OPTS="${CFLAGS}" \
		PTHREAD_CFLAGS="${PTHREAD_CFLAGS}" \
		PTHREAD_LIBS="${PTHREAD_LIBS}"

PLIST_FILES=	sbin/openser sbin/openserctl sbin/openserunix \
		lib/openser/openserctl/openserctl.base lib/openser/openserctl/openserctl.ctlbase \
		lib/openser/openserctl/openserctl.fifo lib/openser/openserctl/openserctl.sqlbase \
		lib/openser/openserctl/openserctl.unixsock

PLIST_DIRS=	lib/openser/modules lib/openser/openserctl lib/openser

MODULES=	acc alias_db auth auth_db auth_diameter avpops cpl-c dbtext \
		dialog dispatcher diversion domain enum exec flatstore gflags \
		group lcr mangler maxfwd mediaproxy msilo nathelper options \
		pa path pdt permissions pike registrar rr siptrace sl sms \
		speeddial statistics textops tm uac uac_redirect uri \
		uri_db usrloc xlog

RC_FILES=	acc/radiusclient.conf \
		acc/servers \
		dictionary.radius \
		openser.cfg
RC_DIRS=	acc

MAN5=		openser.cfg.5
MAN8=		openser.8 \
		openserctl.8

PORTDOCS=	*

SUB_FILES=	pkg-install pkg-deinstall
SUB_LIST=	RC_DIRS="${RC_DIRS}" RC_FILES="${RC_FILES}"

OPTIONS=	MYSQL "MySQL support" on \
		POSTGRESQL "PostgreSQL support" on \
		UNIXODBC "UnixODBC support" on \
		TLS "TLS support" on

.include <bsd.port.pre.mk>

.if defined(WITH_MYSQL)
USE_MYSQL=	yes
MODULES+=	mysql
PLIST_FILES+=	lib/openser/openserctl/openserctl.mysql sbin/openser_mysql.sh
.else
MAKE_ENV+=	MYSQL=mysql
.endif

.if defined(WITH_POSTGRESQL)
USE_PGSQL=	yes
MODULES+=	postgres
PLIST_FILES+=	lib/openser/openserctl/openserctl.pgsql sbin/openser_postgresql.sh
.else
MAKE_ENV+=	POSTGRESQL=postgres
.endif

.if defined(WITH_UNIXODBC)
LIB_DEPENDS+=	odbc.1:${PORTSDIR}/databases/unixODBC
MODULES+=	unixodbc
.else
MAKE_ENV+=	UNIXODBC=unixodbc
.endif

.if defined(WITH_TLS)
.include "${PORTSDIR}/Mk/bsd.openssl.mk"
TLS_RC_FILES=	tls/rootCA/cacert.pem \
		tls/rootCA/certs/01.pem \
		tls/rootCA/index.txt \
		tls/rootCA/private/cakey.pem \
		tls/rootCA/serial \
		tls/user/user-calist.pem \
		tls/user/user-cert.pem \
		tls/user/user-cert_req.pem \
		tls/user/user-privkey.pem
RC_FILES+=	${TLS_RC_FILES}
TLS_RC_DIRS=	tls/user \
		tls/rootCA/certs \
		tls/rootCA/private \
		tls/rootCA \
		tls
RC_DIRS+=	${TLS_RC_DIRS}
.else
MAKE_ARGS+=	TLS=""
.endif

PLIST_FILES+=	${MODULES:S|^|lib/openser/modules/|:S|$|.so|} \
		${RC_FILES:S|^|etc/openser/|:S|$|.default|}

post-patch:
.if defined(NOPORTDOCS)
	@${REINPLACE_CMD} -e 's|install-doc install-man|install-man|' \
		${WRKSRC}/Makefile
.endif
	@${REINPLACE_CMD} -e 's|-g -O9 ||' -e 's|-O9 ||' ${WRKSRC}/Makefile.defs
	@${REINPLACE_CMD} -e 's|/usr/local/etc/ser|${PREFIX}/etc/openser|' \
		${WRKSRC}/scripts/sc.dbtext \
		${WRKSRC}/modules/dispatcher/README
	@${REINPLACE_CMD} -e 's|/etc/openser|${PREFIX}/etc/openser|' \
		${WRKSRC}/modules/mediaproxy/README \
		${WRKSRC}/modules/cpl-c/README \
		${WRKSRC}/INSTALL
	@${REINPLACE_CMD} -e 's|/usr/local|${PREFIX}|' \
		${WRKSRC}/etc/openser.cfg \
		${WRKSRC}/scripts/mysqldb.sh \
		${WRKSRC}/scripts/postgresqldb.sh \
		${WRKSRC}/scripts/sc.dbtext \
		${WRKSRC}/modules/speeddial/README
	@${REINPLACE_CMD} -e 's|/usr/local|${LOCALBASE}|' \
		${WRKSRC}/modules/acc/etc/radiusclient.conf
	@${REINPLACE_CMD} -e 's|/usr/local/etc/radiusclient|${PREFIX}/etc/openser/acc|' \
		${WRKSRC}/modules/acc/acc_mod.c ${WRKSRC}/modules/acc/README

post-install:
	${INSTALL_DATA} ${WRKSRC}/etc/openser.cfg \
		${PREFIX}/etc/openser/openser.cfg.default
	${MKDIR} ${PREFIX}/etc/openser/acc
	${INSTALL_DATA} ${WRKSRC}/modules/acc/etc/radiusclient.conf \
		${PREFIX}/etc/openser/acc/radiusclient.conf.default
	${INSTALL_DATA} ${WRKSRC}/modules/acc/etc/servers \
		${PREFIX}/etc/openser/acc/servers.default
.for d in ${TLS_RC_DIRS}
	${MKDIR} ${PREFIX}/etc/openser/${d}
.endfor
.for f in ${TLS_RC_FILES}
	${INSTALL_DATA} ${WRKSRC}/etc/${f} ${PREFIX}/etc/openser/${f}.default
.endfor
	@PKG_PREFIX=${PREFIX} ${SH} ${PKGINSTALL} ${PKGNAME} POST-INSTALL

.include <bsd.port.post.mk>

=== packaging/netbsd/Makefile ===
# New ports collection makefile for:    openser
#
# $NetBSD$
#
# $Id: Makefile 1811 2007-03-10 18:39:42Z miconda $
#

COMMENT= "OpenSER"

PORTNAME= openser
PORTVERSION= 1.2.0
CATEGORIES= net
MASTER_SITES= http://openser.org/pub/openser/1.2.0/src/

MAINTAINER= daniel@voice-system.ro

MAN8=openser.8
MAN5=openser.cfg.5
# MANCOMPRESSED must not be specified (if defined is assumed to be yes)


USE_GMAKE= yes
# we override the DISTFILE NAME
DISTNAME= ${PORTNAME}-${PORTVERSION}
DISTFILES= ${DISTNAME}_src.tar.gz
WRKSRC= ${WRKDIR}/${PORTNAME}-${PORTVERSION}

# build by default mysql and jabber
MAKE_ENV= include_modules="mysql jabber"

# depends on expat and mysqlclient because of the above modules
DEPENDS= expat-[0-9]*:../../textproc/expat \
         mysql-client>=3.23.35:../../databases/mysql-client

#.include "/usr/pkgsrc/mk/bsd.prefs.mk"

pre-fetch:

.include "../../mk/bsd.pkg.mk"

=== packaging/debian/changelog ===
openser (1.2.0-0) unstable; urgency=low

  * debian/control:
    + New packages: openser-presence-modules, openser-xmlrpc-module,
      openser-perl-module, openser-snmpstats-module, openser-xmpp-module
      (split from the -jabber-module package).
    + Build-Depends: libxmlrpc-c3-dev, libperl-dev, libsnmp9-dev.
  * debian/rules:
    + Always build the non-TLS flavour for Debian builds.
    + Add the new modules.
  * debian/openser.init:
    + Print out error messages if openser fails to start.
    + No longer needs to be run as root to dump core.
  * debian/patches/01_sourced_scripts.dpatch:
    + Removed; merged upstream.
  * debian/patches/02_openser.cfg.dpatch:
    + Removed; no longer needed.
  * debian/patches/12_fail_on_build_failure.dpatch:
    + Removed; merged upstream.
  * debian/patches/22_OpenPKG-SA-2006.042.dpatch:
    + Removed; fixed upstream (different fix).

 -- Julien BLACHE <jblache@debian.org>  Sat, 10 Mar 2007 19:43:06 +0100

openser (1.1.1-1) unstable; urgency=low

  * New upstream bugfix release.
  * debian/patches/21_arm_register_overlap.dpatch:
    + Removed; Merged upstream.
  * debian/patches/20_pdt_domains.c_lockfix.dpatch:
    + Removed; Merged upstream.

 -- Julien BLACHE <jblache@debian.org>  Fri, 26 Jan 2007 16:58:48 +0100

openser (1.1.0-9) unstable; urgency=medium

  * debian/rules:
    + Fix sed substitution pattern to properly get rid of the PATH variable
      in the openserctl, openser_mysql and openser_postgresql scripts.

 -- Julien BLACHE <jblache@debian.org>  Fri, 12 Jan 2007 15:20:26 +0100

openser (1.1.0-8) unstable; urgency=high

  * debian/patches/22_OpenPKG-SA-2006.042.dpatch:
    + Added; security fix for OpenPKG-SA-2006.042 (closes: #404591).

 -- Julien BLACHE <jblache@debian.org>  Tue, 26 Dec 2006 22:13:26 +0100

openser (1.1.0-7) unstable; urgency=low

  * Sync packaging fixes from upstream CVS.
  * debian/control:
    + Fix wrong RFC number in description (3621 vs. 3261), spotted by Dan Pascu.
  * debian/rules:
    + Add avp_radius to RADIUS_MODULES, from Bogdan-Andrei Iancu.

 -- Julien BLACHE <jblache@debian.org>  Fri,  3 Nov 2006 13:35:18 +0100

openser (1.1.0-6) unstable; urgency=low

  * debian/patches/21_arm_register_overlap.dpatch:
    + Added; fix register overlap on arm (closes: #393858).

 -- Julien BLACHE <jblache@debian.org>  Sun, 22 Oct 2006 19:32:55 +0200

openser (1.1.0-5) unstable; urgency=low

  * debian/patches/20_20_pdt_domains.c_lockfix.dpatch:
    + Added; fix typo in modules/pdt/domains.c:306.

 -- Julien BLACHE <jblache@debian.org>  Sun,  8 Oct 2006 19:20:35 +0200

openser (1.1.0-4) unstable; urgency=low

  * debian/control:
    + openser-dbg is Priority: extra.
  * debian/patches/12_fail_on_build_failure.dpatch:
    + Added; abort the build if a module fails to build.
  * debian/rules:
    + Temporarily decrease optimisation on arm (closes: #390005).

 -- Julien BLACHE <jblache@debian.org>  Sun,  8 Oct 2006 12:11:55 +0200

openser (1.1.0-3) unstable; urgency=low

  * debian/rules:
    + Remove DH_COMPAT 4 compatibility code which was introduced only for
      Sarge backward-compatiblity in the upstream CVS; there's now a
      packaging directory dedicated to Sarge.
  * debian/control:
    + Build-Depends cleanup.
  * debian/patches/02_openser.cfg.dpatch:
    + Remove the C-style comment block containing fork=no, otherwise the
      default config file will trigger the test for fork=no in the
      initscript (closes: #386464).
  * debian/openser.README.Debian:
    + Document initscript behaviour wrt fork=no.
  * debian/openser.init:
    + Add LSB header.

 -- Julien BLACHE <jblache@debian.org>  Fri,  8 Sep 2006 15:04:58 +0200

openser (1.1.0-2) unstable; urgency=low

  * Initial Debian release (closes: #380450).

  * Official Debian builds have no TLS support due to the lack of OpenSSL
    license exception for OpenSER. Building TLS packages is supported using
    the upstream TLS tarball with no modifications (you'll need libssl-dev).

  * debian/openser.init:
    + Do not start OpenSER in the start target if fork=no is specified in
      the config file, so as to not break the boot process.
  * debian/rules:
    + Detect TLS/non-TLS sources, and enable TLS build accordingly.
    + get-orig-source will fetch the non-TLS version for the official builds.
    + Emulate debhelper v5 behaviour for debug symbols when build with
      DH_COMPAT 4 to ease Sarge backports.
  * debian/control:
    + Drop build-dependency on libssl-dev for official Debian builds.
    + Simplify dependencies/conflicts.

 -- Julien BLACHE <jblache@debian.org>  Sun, 30 Jul 2006 15:23:13 +0200

openser (1.1.0-1) unstable; urgency=low

  * New upstream release.
    + Packaging updated based on Daniel-Constantin's work upstream.
  * debian/patches/02_postgres_module_build.dpatch:
    + Removed; merged upstream.
  * debian/patches/01_ungentooize.dpatch:
    + Removed; merged upstream.
  * debian/copyright:
    + Updated based on upstream's.
  * debian/openser.postinst:
    + Change openser group GECOS to "OpenSER".
  * debian/control:
    + Rework package descriptions.
    + Add openser-unixodbc-module package.
    + Build-Depend on unixodbc-dev.
  * debian/rules:
    + Build the unixodbc module.
  * debian/patches/01_sourced_scripts.dpatch:
    + Added; remove the shebang line from scripts which aren't meant for
      direct execution.
  * debian/patches/10_no_lib64_on_64_bits.dpatch:
    + Added; use /usr/lib even on 64bit architectures.
  * debian/patches/11_always_smp.dpatch:
    + Added; always build an SMP-enabled OpenSER.

 -- Julien BLACHE <jblache@debian.org>  Wed, 12 Jul 2006 14:37:40 +0200

openser (1.0.1-1) unstable; urgency=low

  * Packaging sanitized.
  * Remove everything debconf-related; setting up an HA cluster is an
    advanced use of OpenSER which cannot be handled through debconf anyway.
  * debian/control:
    + Remove all -tls- packages.
    + Add missing build-depends: zlib1g-dev, flex, bison.


=== packaging/debian/control ===
Source: openser
Section: net
Priority: optional
Maintainer: Debian VoIP Maintainers <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Julien BLACHE <jblache@debian.org>
Build-Depends: debhelper (>= 5), dpatch, libmysqlclient15-dev, libexpat1-dev, libxml2-dev, libpq-dev, libradiusclient-ng-dev, flex, bison, zlib1g-dev, unixodbc-dev, libxmlrpc-c3-dev, libperl-dev, libsnmp9-dev
Standards-Version: 3.7.2

Package: openser
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Suggests: openser-mysql-module, openser-postgres-module, openser-unixodbc-module, openser-jabber-module, openser-cpl-module, openser-radius-modules, openser-presence-modules, openser-xmlrpc-module, openser-perl-module, openser-snmpstats-module, openser-xmpp-module
Description: very fast and configurable SIP proxy
 OpenSER is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, OpenSER can handle thousands calls
 per second even on low-budget hardware.
 .
 C Shell-like scripting language provides full control over the server's
 behaviour. Its modular architecture allows only required functionality to be
 loaded.
 .
 Among others, the following modules are available: Digest Authentication, CPL
 scripts, Instant Messaging, MySQL support, Presence Agent, Radius
 Authentication, Record Routing, SMS Gateway, Jabber/XMPP Gateway, Transaction
 Module, Registrar and User Location, XMLRPC Interface.
 .
 This package contains the main OpenSER binary along with the principal modules
 and support binaries.

Package: openser-dbg
Priority: extra
Architecture: any
Depends: openser (= ${Source-Version})
Conflicts: openser (<< ${Source-Version})
Description: very fast and configurable SIP proxy [debug symbols]
 OpenSER is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, OpenSER can handle thousands calls
 per second even on low-budget hardware.
 .
 This package contains the debugging symbols for the OpenSER binaries and
 modules. You only need to install it if you need to debug OpenSER.

Package: openser-mysql-module
Architecture: any
Depends: ${shlibs:Depends}, openser (= ${Source-Version}), mysql-client
Description: MySQL database connectivity module for OpenSER
 OpenSER is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, OpenSER can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the MySQL database driver for OpenSER.

Package: openser-postgres-module
Architecture: any
Depends: ${shlibs:Depends}, openser (= ${Source-Version}), postgresql-client
Description: PostgreSQL database connectivity module for OpenSER
 OpenSER is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, OpenSER can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the PostgreSQL database driver for OpenSER.

Package: openser-jabber-module
Architecture: any
Depends: ${shlibs:Depends}, openser (= ${Source-Version})
Description: Jabber gateway module for OpenSER
 OpenSER is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, OpenSER can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the SIP to Jabber translator module for OpenSER.

Package: openser-cpl-module
Architecture: any
Depends: ${shlibs:Depends}, openser (= ${Source-Version})
Description: CPL module (CPL interpreter engine) for OpenSER
 OpenSER is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, OpenSER can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides a CPL (Call Processing Language) interpreter for
 OpenSER, turning OpenSER into a CPL server (storage and interpreter).

Package: openser-radius-modules
Architecture: any
Depends: ${shlibs:Depends}, openser (= ${Source-Version})
Description: radius modules for OpenSER
 OpenSER is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, OpenSER can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides a set of Radius modules for OpenSER, for
 authentication, group membership and messages URIs checking against a
 Radius Server.

Package: openser-unixodbc-module 
Architecture: any 
Depends: ${shlibs:Depends}, openser (= ${Source-Version})
Description: unixODBC database connectivity module for OpenSER 
 OpenSER is a very fast and flexible SIP (RFC3261) 
 proxy server. Written entirely in C, OpenSER can handle thousands calls 
 per second even on low-budget hardware. 
 . 
 This package provides the unixODBC database driver for OpenSER. 

Package: openser-presence-modules
Architecture: any
Depends: ${shlibs:Depends}, openser (= ${Source-Version})
Description: SIMPLE presence modules for OpenSER
 OpenSER is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, OpenSER can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides several OpenSER modules for implementing presence
 server and presence user agent for RICH presence, registrar-based presence,
 external triggered presence and XCAP support.

Package: openser-xmlrpc-module
Architecture: any
Depends: ${shlibs:Depends}, openser (= ${Source-Version})
Description: XMLRPC support for OpenSER's Management Interface
 OpenSER is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, OpenSER can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the XMLRPC transport implementation for OpenSER's
 Management Interface.

Package: openser-perl-module
Architecture: any
Depends: ${shlibs:Depends}, openser (= ${Source-Version})
Description: Perl module for OpenSER
 OpenSER is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, OpenSER can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides an interface for OpenSER to write Perl extensions.

Package: openser-snmpstats-module
Architecture: any
Depends: ${shlibs:Depends}, openser (= ${Source-Version}), snmpd
Description: SNMP AgentX subagent module for OpenSER
 OpenSER is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, OpenSER can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the snmpstats module for OpenSER. This module acts
 as an AgentX subagent which connects to a master agent.

Package: openser-xmpp-module
Architecture: any
Depends: ${shlibs:Depends}, openser (= ${Source-Version})
Description: XMPP gateway module for OpenSER
 OpenSER is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, OpenSER can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the SIP to XMPP IM translator module for OpenSER.

=== packaging/debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

ALL_PACKAGES = openser openser-mysql-module openser-postgres-module \
	openser-jabber-module openser-cpl-module openser-radius-modules \
	openser-unixodbc-module openser-presence-modules openser-xmlrpc-module \
	openser-perl-module openser-snmpstats-module openser-xmpp-module

DEBVERSION:=$(shell head -n 1 debian/changelog \
                    | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
UPVERSION:=$(shell echo $(DEBVERSION) | sed -e 's/^.*://' -e 's/-[0-9.]*$$//' -e 's/.dfsg$$//')

FILENAME := openser_$(UPVERSION).orig.tar.gz
UPFILENAME := openser-$(UPVERSION)-tls_src.tar.gz
URL := http://openser.org/pub/openser/$(UPVERSION)/src/openser-$(UPVERSION)-tls_src.tar.gz

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# Include dpatch rules
include /usr/share/dpatch/dpatch.make


# Do we want the TLS version ?
# Disabled by default due to license issues, set to non-void to enable
TLS=

# modules depending on mysql
MYSQL_MODULES = mysql
# modules depending on postgres
POSTGRES_MODULES = postgres
# modules depending on unixODBC
UNIXODBC_MODULES=unixodbc
# jabber module
JABBER_MODULES = jabber
# cpl related modules
CPL_MODULES = cpl-c
# module depending on radiusclient
RADIUS_MODULES = avp_radius auth_radius group_radius uri_radius
# presence related modules
PRESENCE_MODULES = presence pua pua_mi pua_usrloc
# XMLRPC module
XMLRPC_MODULES = mi_xmlrpc
# Perl module
PERL_MODULES = perl
# SNMPstats module
SNMPSTATS_MODULES = snmpstats
# XMPP module
XMPP_MODULES = xmpp

ALL_MODULES = $(MYSQL_MODULES) $(POSTGRES_MODULES) $(UNIXODBC_MODULES) $(JABBER_MODULES) $(CPL_MODULES) $(RADIUS_MODULES) $(PRESENCE_MODULES) $(XMLRPC_MODULES) $(PERL_MODULES) $(SNMPSTATS_MODULES) $(XMPP_MODULES)

# modules not in the "main" package or unstable modules
EXCLUDED_MODULES = $(ALL_MODULES) pa osp

# the same but with path prepended (needed for modules="...")
MYSQL_MOD_PATH=$(addprefix modules/, $(MYSQL_MODULES))
POSTGRES_MOD_PATH=$(addprefix modules/, $(POSTGRES_MODULES))
UNIXODBC_MOD_PATH=$(addprefix modules/, $(UNIXODBC_MODULES))
JABBER_MOD_PATH=$(addprefix modules/, $(JABBER_MODULES))
CPL_MOD_PATH=$(addprefix modules/, $(CPL_MODULES))
RADIUS_MOD_PATH=$(addprefix modules/, $(RADIUS_MODULES))
PRESENCE_MOD_PATH=$(addprefix modules/, $(PRESENCE_MODULES))
XMLRPC_MOD_PATH=$(addprefix modules/, $(XMLRPC_MODULES))
PERL_MOD_PATH=$(addprefix modules/, $(PERL_MODULES))
SNMPSTATS_MOD_PATH=$(addprefix modules/, $(SNMPSTATS_MODULES))
XMPP_MOD_PATH=$(addprefix modules/, $(XMPP_MODULES))

ifeq (cc, $(CC))
	CC = gcc
endif

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
        CFLAGS += -O0
else
	CFLAGS += -O2
endif

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp
build-stamp: patch-stamp configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) all skip_modules="$(EXCLUDED_MODULES)" cfg-target=/etc/openser/
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) modules modules="$(MYSQL_MOD_PATH)" cfg-target=/etc/openser/
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) modules modules="$(POSTGRES_MOD_PATH)" cfg-target=/etc/openser/
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) modules modules="$(UNIXODBC_MOD_PATH)" cfg-target=/etc/openser/
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) modules modules="$(JABBER_MOD_PATH)" cfg-target=/etc/openser/
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) modules modules="$(CPL_MOD_PATH)" cfg-target=/etc/openser/
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) modules modules="$(RADIUS_MOD_PATH)" cfg-target=/etc/openser/
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) modules modules="$(PRESENCE_MOD_PATH)" cfg-target=/etc/openser/
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) modules modules="$(XMLRPC_MOD_PATH)" cfg-target=/etc/openser/
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) modules modules="$(PERL_MOD_PATH)" cfg-target=/etc/openser/
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) modules modules="$(SNMPSTATS_MOD_PATH)" cfg-target=/etc/openser/
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) modules modules="$(XMPP_MOD_PATH)" cfg-target=/etc/openser/

	touch build-stamp

clean: real-clean unpatch
real-clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) TLS=$(TLS) include_modules="$(ALL_MODULES)" proper
	rm -f cfg.tab.h
	rm -f utils/openserunix/openserunix.o utils/openserunix/openserunix

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/openser
	# openser base package
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) install skip_modules="$(EXCLUDED_MODULES)" \
		basedir=$(CURDIR)/debian/openser \
		prefix=/usr \
		cfg-prefix=$(CURDIR)/debian/openser \
		cfg-target=/etc/openser/

	find $(CURDIR)/debian/openser/etc/openser -type f -exec chmod -x {} \;
	sed -i -e "s/^PATH.*//" $(CURDIR)/debian/openser/usr/sbin/openserctl

	# install only the mysql module
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) install-modules-all modules="$(MYSQL_MOD_PATH)"  \
		basedir=$(CURDIR)/debian/openser-mysql-module \
		prefix=/usr \
		cfg-prefix=$(CURDIR)/debian/openser-mysql-module \
		cfg-target=/etc/openser/ \
		doc-dir=share/doc/openser-mysql-module

	mv $(CURDIR)/debian/openser-mysql-module/usr/sbin/openser_mysql.sh $(CURDIR)/debian/openser-mysql-module/usr/sbin/openser_mysql
	sed -i -e "s/^PATH.*//" $(CURDIR)/debian/openser-mysql-module/usr/sbin/openser_mysql
	chmod +x $(CURDIR)/debian/openser-mysql-module/usr/sbin/openser_mysql

	# install only the postgres module
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) install-modules-all modules="$(POSTGRES_MOD_PATH)"  \
		basedir=$(CURDIR)/debian/openser-postgres-module \
		prefix=/usr \
		cfg-prefix=$(CURDIR)/debian/openser-postgres-module \
		cfg-target=/etc/openser/ \
		doc-dir=share/doc/openser-postgres-module

	mv $(CURDIR)/debian/openser-postgres-module/usr/sbin/openser_postgresql.sh $(CURDIR)/debian/openser-postgres-module/usr/sbin/openser_postgresql
	sed -i -e "s/^PATH.*//" $(CURDIR)/debian/openser-postgres-module/usr/sbin/openser_postgresql
	chmod +x $(CURDIR)/debian/openser-postgres-module/usr/sbin/openser_postgresql

	# install only the unixodbc module
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) install-modules-all modules="$(UNIXODBC_MOD_PATH)"  \
		basedir=$(CURDIR)/debian/openser-unixodbc-module \
		prefix=/usr \
		cfg-prefix=$(CURDIR)/debian/openser-unixodbc-module \
		cfg-target=/etc/openser/ \
		doc-dir=share/doc/openser-unixodbc-module

	# install only the jabber module
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) install-modules-all modules="$(JABBER_MOD_PATH)"  \
		basedir=$(CURDIR)/debian/openser-jabber-module \
		prefix=/usr \
		cfg-prefix=$(CURDIR)/debian/openser-jabber-module \
		cfg-target=/etc/openser/ \
		doc-dir=share/doc/openser-jabber-module

	# install only the cpl module
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) install-modules-all modules="$(CPL_MOD_PATH)"  \
		basedir=$(CURDIR)/debian/openser-cpl-module \
		prefix=/usr \
		cfg-prefix=$(CURDIR)/debian/openser-cpl-module \
		cfg-target=/etc/openser/ \
		doc-dir=share/doc/openser-cpl-module

	# install only the radius modules
	CC="$(CC)" CFLAGS="$(CFLAGS)" TLS=$(TLS) $(MAKE) install-modules-all modules="$(RADIUS_MOD_PATH)"  \
		basedir=$(CURDIR)/debian/openser-radius-modules \
		prefix=/usr \
		cfg-prefix=$(CURDIR)/debian/openser-radius-modules \
		cfg-target=/etc/openser/ \
		doc-dir=share/doc/openser-radius-modules

	mkdir -p $(CURDIR)/debian/openser-radius-modules/etc/openser/
